﻿using Infragistics.Windows.Ribbon;
using Infragistics.Windows.Ribbon.Internal;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;

namespace CAS_179006
{
    public partial class MyMenuToolProxy : RibbonToolProxy<MyMenuTool>
    {
        public MyMenuToolProxy()
            : base()
        {
        }
    }

    public partial class MyMenuTool : Menu, IRibbonTool, IKeyTipContainer
    {
        static MyMenuTool()
        {
            RibbonGroup.MaximumSizeProperty.OverrideMetadata(typeof(MyMenuTool),
             new FrameworkPropertyMetadata(RibbonToolSizingMode.ImageAndTextNormal));
        }

        public static readonly DependencyProperty IdProperty = RibbonToolHelper.IdProperty.AddOwner(typeof(MyMenuTool));


        [System.ComponentModel.Bindable(true)]
        public string Id
        {
            get
            {
                return (string)this.GetValue(MyMenuTool.IdProperty);
            }
            set
            {
                this.SetValue(MyMenuTool.IdProperty, value);
            }
        }

        public Infragistics.Windows.Ribbon.Internal.RibbonToolProxy ToolProxy
        {
            get
            {
                return new MyMenuToolProxy();
            }
        }

        void IKeyTipContainer.Deactivate()
        {
            // this.IsOpen = false;
        }

        bool IKeyTipContainer.ReuseParentKeyTips
        {
            get { return false; }
        }

        public IKeyTip[] GetKeyTips()
        {
            var keyTips = new List<IKeyTip>();
            if (Items.Count == 0)
                return keyTips.ToArray();

            foreach (var sub in (this.Items[0] as MenuItem).Items)
            {
                var keyTip = sub as IKeyTip;
                if (keyTip == null)
                    continue;

                keyTips.Add(keyTip);
            }

            (this.Items[0] as MenuItem).IsSubmenuOpen = true;

            return keyTips.ToArray();
        }

    }
}
